<script lang="ts">
	import CardButton from "../ui/CardButton.svelte";
	import { DomainNameType } from "../types";
	import OwnDomainNames from "../provider/OwnDomainNames";
	import { debounce } from "../utils";
	import { fly } from "svelte/transition";
	import { EXAMPLE_DOMAIN, EXAMPLE_SUBDOMAIN_PREFIX } from "../entity/OrderForm";

	export let domainType: DomainNameType = null;
	export let fullyQualifiedDomainName: string;
	export let subdomainError = "";
	export let domainNameError = "";

	const DOMAIN_VALIDATOR_URL = "https://buscarron.etke.cc/_domain?domain=";

	let setValue = function (newValue: DomainNameType): void {
		domainType = newValue;
		// domain errors needs to be cleaned on toggle as we use them in OrderForm component
		subdomainError = "";
		domainNameError = "";
	};

	let ourDomains = OwnDomainNames;
	let ourDomain = ourDomains[0];

	let domainNameBase = ""; // will be obtained from the API, which will strip the subdomain part
	let domainName = "";
	let subdomainName = "";
	let ownSubdomainsCount = OwnDomainNames.length;

	const handleDomainChange = ({ currentTarget: { value } }) => {
		domainName = value;
		getDomainNameBase(value);
	};

	const handleSubDomainInputChange = (event) => {
		subdomainName = event.target.value;
		constructFullyQualifiedDomainName(true);
		debounce(() => {
			checkSubdomainNameValidity(subdomainName);
		}, 200)();
	};

	const onChangeOurDomain = () => {
		constructFullyQualifiedDomainName(true);
		if (subdomainName) {
			checkSubdomainNameValidity(subdomainName);
		}
	};

	let checkSubdomainNameValidity = async (subdomainName: string) => {
		if (subdomainName.length < 3) {
			subdomainError = "Error: subdomain is too short.";
			return;
		}

		// Multiple levels (e.g. `sub.sub`) are not allowed.
		// We don't even need to ask the backend.
		if (subdomainName.indexOf(".") != -1) {
			subdomainError = "Error: multiple levels are not allowed.";
			return;
		}

		try {
			const response = await fetch(
				DOMAIN_VALIDATOR_URL + fullyQualifiedDomainName,
			);
			if (!response.ok) {
				subdomainError =
					response.status === 409
						? "Subdomain is already taken, please choose something else."
						: "Error: Something went wrong. Please try again later.";
				return;
			}
			subdomainError = "";
		} catch (err) {
			subdomainError = "Couldn't check domain availability";
		}
	};

	let getDomainNameBase = (domainName: string) => {
		debounce(async () => {
			if (!domainName.includes(".")) {
				// not a valid domain
				domainNameError = "Domain name is not valid.";
				return;
			}
			if (domainName === EXAMPLE_DOMAIN) {
				domainNameError = "Please use an actual domain, not the example one.";
				return;
			}

			const response = await fetch(DOMAIN_VALIDATOR_URL + domainName);
			try {
				const respJson = await response.json();
				if (respJson.error === "invalid domain") {
					domainNameError = "Domain name is not valid.";
					return;
				}
				if (respJson.base) {
					domainNameBase = respJson.base;
					domainNameError = "";
				}
			} catch (err) {}
			constructFullyQualifiedDomainName(false);
		}, 200)();
	};

	const constructFullyQualifiedDomainName = (fromSubdomain: boolean) => {
		if (fromSubdomain) {
			fullyQualifiedDomainName = (subdomainName !== "" ? subdomainName : EXAMPLE_SUBDOMAIN_PREFIX) + "." + ourDomain;
		} else {
			fullyQualifiedDomainName = domainNameBase !== "" ? domainNameBase : EXAMPLE_DOMAIN;
		}
	};

	let domainRotationIndex = 0;
	let domainRotation = OwnDomainNames[domainRotationIndex];
	setInterval(() => {
		domainRotationIndex++;
		if (domainRotationIndex >= OwnDomainNames.length) {
			domainRotationIndex = 0;
		}

		domainRotation = OwnDomainNames[domainRotationIndex];
	}, 1500);

	$: if (domainType === DomainNameType.ManagedSubdomain) {
		constructFullyQualifiedDomainName(true);
	}
	$: if (domainType === DomainNameType.OwnDomain) {
		constructFullyQualifiedDomainName(false);
	}
</script>

<div class="row">
	<div class="col-md-6 mb-2">
		<CardButton
			multipleSelect={false}
			active={domainType === DomainNameType.ManagedSubdomain}
			faded={domainType !== DomainNameType.ManagedSubdomain &&
				domainType !== null}
			on:activated={() => setValue(DomainNameType.ManagedSubdomain)}
		>
			<div slot="card-body-heading">
				<h4 class="fs-5">
					Subdomain of Ours e.g.
					<code>
						mybusiness.{#key domainRotation}<span class="d-inline-block" in:fly={{ y: -40 }}><strong>{domainRotation}</strong></span>{/key}
					</code>
				</h4>
			</div>

			<div slot="card-body-content">
				<p class="mb-1">
					Use a <strong>free</strong> subdomain on one of our
					<strong>{ownSubdomainsCount}</strong> top-level domains.
				</p>
				<p class="mb-1">No setup required on your part.</p>
			</div>
		</CardButton>
	</div>

	<div class="col-md-6 mb-2">
		<CardButton
			multipleSelect={false}
			active={domainType === DomainNameType.OwnDomain}
			faded={domainType !== DomainNameType.OwnDomain &&
				domainType !== null}
			on:activated={() => setValue(DomainNameType.OwnDomain)}
		>
			<div slot="card-body-heading">
				<h4 class="fs-5">
					Custom Domain e.g. <code>{EXAMPLE_DOMAIN}</code>
				</h4>
			</div>

			<div slot="card-body-content">
				<p class="mb-1">
					Use your <strong>own</strong> domain which you've
					<strong>bought separately</strong>.
				</p>
				<p class="mb-1">You'll need to do some DNS setup.</p>
			</div>
		</CardButton>
	</div>

	<div class="col-md-12 mb-2">
		{#if domainType === DomainNameType.OwnDomain}
			<label for="domain-name" class="mb-2 d-inline-block">Domain name:</label>
			<input
				id="domain-name"
				class="form-control mb-2"
				class:input-fail={domainNameError}
				class:input-success={!domainNameError && domainName !== ""}
				type="text"
				placeholder={EXAMPLE_DOMAIN}
				autocomplete="off"
				bind:value={domainName}
				on:input={handleDomainChange}
			/>
			{#if domainNameError}
				<p class="text-danger">{domainNameError}</p>
			{/if}
			<p>We’ll ask you to create subdomains like <code>matrix.{fullyQualifiedDomainName}</code>, etc.</p>
		{:else if domainType === DomainNameType.ManagedSubdomain}
			<label for="domain-name" class="mb-2 d-inline-block">Subdomain name:</label>
			<div class="d-flex flex-row mb-2">
				<input
					id="domain-name"
					class="form-control d-inline"
					class:input-fail={subdomainError}
					class:input-success={!subdomainError && subdomainName !== ""}
					type="text"
					placeholder={EXAMPLE_SUBDOMAIN_PREFIX}
					autocomplete="off"
					bind:value={subdomainName}
					on:input={handleSubDomainInputChange}
				/>
				<select
					class="form-select"
					bind:value={ourDomain}
					on:change={onChangeOurDomain}
				>
					{#each ourDomains as ourDomain}
						<option value={ourDomain}>{ourDomain}</option>
					{/each}
				</select>
			</div>
			{#if subdomainError}
				<p class="text-danger">{subdomainError}</p>
			{/if}
		{/if}
		{#if domainType !== null}
			<p>
				Usernames on your server will look like this: <code>@username:{fullyQualifiedDomainName}</code>
			</p>
		{/if}
	</div>
</div>
